# include <qsize.h>
# include <mylib.h>
# include <main.h>
# include <slowo.h>

short  tcolor( char *str );
QColor TColor( char c );

/***************************************************************************/

/***************************************************************************/
t_Stande :: t_Stande( QWidget *parent, const char *name ) :
	    QWidget( parent, name )
{  short i ;

   fs=NULL ;
   fsUp=0 ;
   i_Dict=i_List=0 ;

   setGeometry( 0,0,500,300 );
   x_color=320 ;
   y_color= 20 ;

   Pix  = new QPixmap( 200,300 );

   QPainter *GC0 ;
   GC0 = new QPainter( Pix ) ;

   GC0->setPen( NoPen );
   GC0->setBrush( QColor(0,0,0) );
   GC0->drawRect( 0, 0, 200, 300 );
   delete( GC0 );

   QPainter GC1( this ) ;
   GC1.drawPixmap( 0, 0,*Pix,0,0,200,300 );

   Dict = new QComboBox( this );
   Dict->insertItem(" ");
   for( i=0 ; i<n_Files ; i++ )
      Dict->insertItem( Files[i] );
   Dict->setCurrentItem( 0 );

   List = new QListBox( this ) ;
   List->insertItem( "  " );
   List->insertItem( " " );
   List->insertItem( " " );
   List->insertItem( "" );
   List->insertItem( "" );
   List->setCurrentItem( 0 );

   Trans   = new QCheckBox( "",this ) ;
   Divider = new QLineEdit( this );
   Font    = new QLineEdit( this );
   BFont   = new QPushButton( "Select",this );

   LDict    = new QLabel( ""     ,this );
   LList    = new QLabel( ""       ,this );
   LTrans   = new QLabel( "",this );
   LDivider = new QLabel( "" ,this );
   LFont    = new QLabel( ""       ,this );

   Group  = new QGroupBox( this );
   //Help   = new QPushButton( "Help"  ,this );
   Cancel = new QPushButton( "Cancel",this );
   Ok     = new QPushButton( "Ok"    ,this );

   QSize        Size( 500,300 );
   QResizeEvent E( Size, Size ) ;
   resizeEvent( &E );

   connect( Dict  , SIGNAL(highlighted(int)), SLOT(doDictSelect(int)) );
   connect( List  , SIGNAL(highlighted(int)), SLOT(doListSelect(int)) );

   connect( BFont , SIGNAL(clicked()), SLOT(selectFont()) );
   connect( Ok    , SIGNAL(clicked()), SLOT(doOk()) );
   connect( Cancel, SIGNAL(clicked()), SLOT(doCancel()) );
   doDictSelect( 0 );
}
/* ----------------------------------------------------------------------- */
void t_Stande :: resizeEvent( QResizeEvent *E )
{  long w,h,w0,h1 ;

   w0=E->size().width() ;
   h=E->size().height() ;
   w=w0-200 ;

//   x_color=320*w/500 ;
   x_color=200+120*w/300 ;
   y_color= 20*h/300 ;

   Dict    ->setGeometry( 200,  40*h/300,100*w/300, 20*h/300 );
   List    ->setGeometry( 200,  80*h/300,100*w/300,100*h/300 );

   Trans   ->setGeometry( 205, 275*h/300, 10*w/300, 10*h/300 );
   Divider ->setGeometry( 200, 250*h/300, 50*w/300, 20*h/300 );
   Font    ->setGeometry( 200, 210*h/300,300*w/300, 20*h/300 );
   BFont   ->setGeometry( 200+150*w/300, 240*h/300, 50*w/300, 20*h/300 );

   LDict   ->setGeometry( 200,  20*h/300,100*w/300, 20*h/300 );
   LList   ->setGeometry( 200,  60*h/300,100*w/300, 20*h/300 );
   LTrans  ->setGeometry( 220, 270*h/300,100*w/300, 20*h/300 );
   LDivider->setGeometry( 200, 230*h/300,100*w/300, 20*h/300 );
   LFont   ->setGeometry( 200, 190*h/300,100*w/300, 20*h/300 );

   Group   ->setGeometry( 200+220*w/300, 230*h/300, 70*w/300, 65*h/300 );
   Cancel  ->setGeometry( 200+230*w/300, 240*h/300, 50*w/300, 20*h/300 );
   Ok      ->setGeometry( 200+230*w/300, 265*h/300, 50*w/300, 20*h/300 );
   
}
/* ----------------------------------------------------------------------- */
void t_Stande::paintEvent( QPaintEvent * )
{
   short sx=10*(width()-200)/300 ;
   short sy=10*height()/300 ;
   short TT ;

   QPainter GC1( this ) ;

   for( short x=0 ; x<16 ; x++ )
   {  if( x<8 ) TT=127 ; else TT=255 ;
      GC1.setBrush( QColor( TT*((x&0x01)!=0) ,TT*((x&0x02)!=0), TT*((x&0x04)!=0)) );
      if( x==8 ) GC1.setBrush( QColor( 197,197,197 ) );
      GC1.drawRect( x_color+x*sx, y_color, sx, 16*sy );
      for( short y=0 ; y<16 ; y++ )
      {  if( y<8 ) TT=127 ; else TT=255 ;
         GC1.setBrush( QColor( TT*((y&0x01)!=0) ,TT*((y&0x02)!=0), TT*((y&0x04)!=0)) );
	 GC1.drawRect( x_color+sx/4+x*sx, y_color+sy/4+y*sy,sx/2,sy/2 );
      }
   }

   QPainter *GC0 = new QPainter( Pix ) ;

   GC0->setPen( QPen( QColor( 197,197,197 ),3) );
   GC0->setBrush( NoBrush );
   GC0->drawRect(  5,  5, 170, 270 );
   GC0->drawRect(  5,120, 170,  20 );
   GC0->drawRect(  5,140, 170,  20 );
   GC0->setPen( QPen( QColor( 0,0,0 ),1) );
   //GC0->setBrush( QColor(255,255,255) );
   GC0->setBrush( TColor( (my_Stande.Text[1].color>>4)&0x0f ) );
   GC0->drawRect(  7, 27, 156,  92 );
   GC0->setBrush( TColor( (my_Stande.Text[2].color>>4)&0x0f ) );
   GC0->drawRect(  7,121, 166,  18 );
   GC0->setBrush( TColor( (my_Stande.Text[3].color>>4)&0x0f ) );
   GC0->drawRect(  7,141, 166,  18 );
   GC0->setBrush( TColor( (my_Stande.Text[4].color>>4)&0x0f ) );
   GC0->drawRect(  7,161, 166, 111 );
   GC0->setBrush( QColor( 197,197,197 ) );
   GC0->drawRect(  163, 27, 10,  92 );
   GC0->setBrush( QColor( 197,197,197 ) );
   GC0->drawRect(  163, 50, 10, 15 );
   GC0->setPen( NoPen );
   GC0->setBrush( TColor( (my_Stande.Text[0].color>>4)&0x0f ) );
   GC0->drawRect(  5,  5, 170, 20 );
   GC0->setPen( QColor( 0,0,0 ) );

{  QFont FF( my_Stande.Text[0].Font );
   FF.setRawMode( TRUE );
   GC0->setFont( FF );
   GC0->setPen( TColor( my_Stande.Text[0].color ) );
   GC0->drawText( 10, 20, "Menu" );
}   
{  QFont FF( my_Stande.Text[1].Font );
   FF.setRawMode( TRUE );
   GC0->setFont( FF );
   GC0->setPen( TColor( my_Stande.Text[1].color ) );
   GC0->drawText( 10, 40, "slowo" );
   GC0->drawText( 10, 60, "slowo" );
}
{  QFont FF( my_Stande.Text[2].Font );
   FF.setRawMode( TRUE );
   GC0->setFont( FF );
   GC0->setPen( TColor( my_Stande.Text[2].color ) );
   GC0->drawText( 10,138, "slowo" );
}   
{  QFont FF( my_Stande.Text[3].Font );
   FF.setRawMode( TRUE );
   GC0->setFont( FF );
   GC0->setPen( TColor( my_Stande.Text[3].color ) );
   GC0->drawText( 10,158, "slowo" );
}   
{  QFont FF( my_Stande.Text[4].Font );
   FF.setRawMode( TRUE );
   GC0->setFont( FF );
   GC0->setPen( TColor( my_Stande.Text[4].color ) );
   GC0->drawText( 10,180, "" );
}   
   
   delete( GC0 );

   //QPainter GC1( this ) ;
   GC1.drawPixmap( 10, 10,*Pix,0,0,180,280 );
}
/* ----------------------------------------------------------------------- */
void t_Stande::mousePressEvent( QMouseEvent *Event )
{  short i,x,y,x1,y1 ;
   
   short sx=10*(width()-200)/300 ;
   short sy=10*height()/300 ;

   x=Event->x() ;
   y=Event->y() ;
   x1=(x-x_color)/sx ;
   y1=(y-y_color)/sy ;
   
   if( x1<0 || 15<x1 ) return ;
   if( y1<0 || 15<y1 ) return ;
   my_Stande.Text[i_List].color=(x1<<4)+y1 ;
   paintEvent( NULL );      
}
/* ----------------------------------------------------------------------- */
void t_Stande::selectFont( void )
{
    if (!fs) {
	fs   = new FontSelect ;
	fs->setGeometry( QRect( 100, 200, 380, 260 ) );
	fsUp = FALSE;
	connect( fs, SIGNAL(newFont(const QFont &)), SLOT(setFont(const QFont &)) );
    }
    fsUp = !fsUp;
    if ( fsUp )
	fs->show();
    else
	fs->hide();
}
/* ----------------------------------------------------------------------- */
void t_Stande::doDictSelect( int i )
{
  printf("select %d Dict\n",i ) ;
  i_Dict=i ;
  my_Stande=Stande1.Dict[i_Dict] ;
  Divider->setText( my_Stande.Divider );
  Trans->setChecked( my_Stande.fTrans );
  Font->setText(  my_Stande.Text[i_List].Font );  
}
/* ----------------------------------------------------------------------- */
void t_Stande::doListSelect( int i )
{  
   i_List=i ;
   Font->setText(  my_Stande.Text[i_List].Font );
}
/* ----------------------------------------------------------------------- */
void t_Stande::doOk( void )
{
   printf("select\n" );
   Stande1.Dict[i_Dict]=my_Stande ;
   strcpy( Stande1.Dict[i_Dict].Divider,Divider->text() );
   Stande1.Dict[i_Dict].fTrans =Trans->isChecked() ;

   Forever->set_param( );
}
/* ----------------------------------------------------------------------- */
void t_Stande::doCancel( void )
{
    if( fsUp ) fs->hide( );
    hide( );
}
/* ----------------------------------------------------------------------- */
void t_Stande::setFont( const QFont &_Font )
{
   strcpy( my_Stande.Text[i_List].Font, _Font.rawName()) ;
   Font->setText(  _Font.rawName() );
   paintEvent( NULL );   
}
/* ----------------------------------------------------------------------- */
void t_Stande::setColor( char _Color )
{
   my_Stande.Text[i_List].color=_Color ;
}
/* ----------------------------------------------------------------------- */
void t_Stande1::init( void )
{  short i,i1 ;

   Dict=(t_DictStande *)Calloc( n_Files+1,sizeof(t_DictStande));
   for( i=0 ; i<=n_Files ; i++ )
   {
      strcpy( Dict[i].Divider,"=" );
      Dict[i].fTrans=0 ;
      for( i1=0 ; i1<5 ; i1++ )
      {  Dict[i].Text[i1].color=0xf0 ;
	 strcpy( Dict[i].Text[i1].Font,
		 "-cronyx-courier-medium-r-normal--17-120-100-100-m-90-koi8-r" );
	 if( i1==3 )
	 strcpy( Dict[i].Text[i1].Font,
		 "-unknown-sildoulosipa-regular-r-normal--17-120-100-100-p-90-adobe-fontspecific" );
      }
   }
}
/***************************************************************************/
/*                                                  */
/***************************************************************************/
char t_Stande1::read1( void )
{
   char  *h,*Val ;
   char   File[200],Var[200],Prefix[50] ;

   i_default_Dict=0 ;
   File[0]=0 ;
   h=getenv( "HOME" );
   if( h!=NULL ) strcpy( File,h );
   strcat( File,"/.slowo.ini" );

   if( 0!=load_rcfile( File, "" ) ) return -1 ;

   Val=get_value( "Path" );
   if( Val!=NULL ) strcpy( StartPath,Val ) ;
   return 0 ;
}
/* ----------------------------------------------------------------------- */
void  t_Stande1:: read2( void )
{
   short  i,i1,L ;
   char  *h,*Val ;
   FILE  *fw ;
   char   File[200],Var[200],Prefix[50] ;
   char  *DefaultDict ;

   DefaultDict=get_value( "DefaultDict" );
   for( i=0 ; i<=n_Files ; i++ )
   {
      if( i==0 ) strcpy( Prefix,"" );
      else
      {  strcpy( Prefix,Files[i-1] );
	 L=strlen( Prefix );
	 Prefix[L-4]=':' ; Prefix[L-3]=0 ;
	 if( DefaultDict!=NULL && 0==strcmp( Files[i-1],DefaultDict ) )
	     i_default_Dict=i-1 ;
      }
      if( i!=0 ) Dict[i]=Dict[0] ;

      sprintf( Var,"%s%s",Prefix,"List.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[1].Font,Val );

      sprintf( Var,"%s%s",Prefix,"Word.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[2].Font,Val );

      sprintf( Var,"%s%s",Prefix,"Transcript.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[3].Font,Val );

      sprintf( Var,"%s%s",Prefix,"Translate.Font" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Text[4].Font,Val );

      sprintf( Var,"%s%s",Prefix,"List.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[1].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Word.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[2].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Transcript.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[3].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Translate.Color" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].Text[4].color=tcolor(Val);

      sprintf( Var,"%s%s",Prefix,"Divider" );
      Val=get_value( Var );
      if( Val!=NULL ) strcpy( Dict[i].Divider,Val );

      sprintf( Var,"%s%s",Prefix,"SortOrder" );
      Val=get_value( Var );
      if( Val!=NULL && 0==strcmp(Val,"Euro") )
	  Dict[i].SortOrder=1 ;

      sprintf( Var,"%s%s",Prefix,"Translate" );
      Val=get_value( Var );
      if( Val!=NULL ) Dict[i].fTrans=(0==strcmp( "1",Val ));
   }
}
/* ----------------------------------------------------------------------- */
void  t_Stande1:: write( void )
{
   short  i,i1,L ;
   char  *h ;
   FILE  *fw ;
   char   File[200],Prefix[50]="" ;

   File[0]=0 ;
   h=getenv( "HOME" );
   if( h!=NULL ) strcpy( File,h );
   strcat( File,"/.slowo.ini" );

   fw=Fopen( File,"w" );

   fprintf( fw,"Path %s",StartPath );

   for( i=0 ; i<=n_Files ; i++ )
   {
      if( i!=0 )
      {  strcpy( Prefix,Files[i-1] );
	 L=strlen( Prefix );
	 Prefix[L-4]=0 ;
	 fprintf( fw,"\n%s\n{",Prefix );
	 Prefix[L-4]=':' ; Prefix[L-3]=0 ;
      }

      fprintf( fw,"\nList.Font        %s",Dict[i].Text[1].Font );
      fprintf( fw,"\nWord.Font        %s",Dict[i].Text[2].Font );
      fprintf( fw,"\nTranscript.Font  %s",Dict[i].Text[3].Font );
      fprintf( fw,"\nTranslate.Font   %s",Dict[i].Text[4].Font );

      fprintf( fw,"\nList.Color       0x%02x",Dict[i].Text[1].color&0x0ff );
      fprintf( fw,"\nWord.Color       0x%02x",Dict[i].Text[2].color&0x0ff );
      fprintf( fw,"\nTranscript.Color 0x%02x",Dict[i].Text[3].color&0x0ff );
      fprintf( fw,"\nTranslate.Color  0x%02x",Dict[i].Text[4].color&0x0ff );

      fprintf( fw,"\nDivider          \"%s\"",Dict[i].Divider );
      fprintf( fw,"\nTranslate        %d",Dict[i].fTrans );

      if( i!=0 )
      {   fprintf( fw,"\n}" );  }
   }

   fclose( fw );
}
/* ----------------------------------------------------------------------- */
short tcolor( char *str )
{  short f1=0,f2=7 ;

   if( str[0]!='0' || str[1]!='x' ) return -1 ;
   if( '0'<=str[2] && str[2]<='9' ) f1=str[2]-'0' ;
   if( 'a'<=str[2] && str[2]<='f' ) f1=str[2]-'a'+10 ;
   if( 'A'<=str[2] && str[2]<='F' ) f1=str[2]-'A'+10 ;
   if( '0'<=str[3] && str[3]<='9' ) f2=str[3]-'0' ;
   if( 'a'<=str[3] && str[3]<='f' ) f2=str[3]-'a'+10 ;
   if( 'A'<=str[3] && str[3]<='F' ) f2=str[3]-'A'+10 ;
   return (f1<<4)+f2 ;
}
/* ----------------------------------------------------------------------- */
QColor TColor( char c )
{  short TT ;
   if( 7<c ) TT=255 ; else TT=127 ;
   if( 8==c ) return QColor( 198 , 198, 198 ) ;
   return QColor( TT*((c&0x04)!=0) ,TT*((c&0x02)!=0), TT*((c&0x01)!=0)) ;
}
