/****************************************************************************
   This is a part of programm of Dictionary for UNIX
   Copyright (C) 1999 Anisimow Dmitry.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
/***************************************************************************/
/*      X-Window                            */
/*                                                                         */
/***************************************************************************/
# include <stdio.h>
# include <stdlib.h>
# include <X11/Xlib.h>
# include <X11/Xutil.h>
# include <X11/Xos.h>
# include <X11/keysym.h>
# include <X11/Intrinsic.h>
# include <X11/StringDefs.h>

# include "s_defkey.h"
# include "x_schone.h"
# include "slowo.xbm"

Display     *Dis ;
int          i_Scr ;
//GC           DrawGC ;
static Window   Win=0 ;
Colormap     Colormap1 ;
XColor       Color[16] ;
//XFontStruct *FontInfo ;

//short    x,y ;
//int      Symbol_W,Symbol_H;      /*     */
short    Size_X,Size_Y ;
int      Shiftstatus ;           /*     */
//char    *FontName ;

/***************************************************************************/
/*                                                         */
/***************************************************************************/
void x_begin_schone( int argc, char *argv[] )
{
   short i,f=0 ;
   XSizeHints    SizeHints ;
   XWMHints      WMHints ;
   XClassHint    ClassHint ;
   XTextProperty WinName,IconName ;

   // ---------------   ---------------------------

   Dis   = XOpenDisplay(NULL) ;
   i_Scr = DefaultScreen(Dis) ;

   // --------------     ----------------
/*
   for( i=0 ; i<argc-1 ; i++ )
      if( 0==strcmp( argv[i], "-fn" ) )
      {  FontName=(char *)Calloc( strlen(argv[i+1])+1,sizeof(char) );
	 strcpy( FontName,argv[i+1] );
	 f=1 ;
      }

   if( f==0 ) FontName="-cronyx-times-bold-i-normal--14-100-100-100-p-54-koi8-r" ;

   if((FontInfo = XLoadQueryFont( Dis, FontName )) == NULL)
   {  printf( "\n Error load font:%s",FontName ); exit(-1);  }
   Symbol_W = FontInfo->max_bounds.width;
   Symbol_H = FontInfo->ascent + FontInfo->descent;
   Size_X=40*Symbol_W ; Size_Y=20*Symbol_H ;
*/
   Size_X=Size_Y=400 ;
   // ---------------   --------------------------

   Win   = XCreateSimpleWindow( Dis,RootWindow( Dis,i_Scr),
	   0,0,Size_X,Size_Y,5, BlackPixel(Dis,i_Scr), BlackPixel(Dis,i_Scr) );

   // ---------------   --------------------------

   Colormap1 = DefaultColormap( Dis,DefaultScreen(Dis) );
   for( i=0 ; i<16 ; i++ )
   {  XColor Color1 ;
      unsigned short V ;

      if( i>=8 ) V=0x8000 ; else V=0 ;
      if( (i&0x01)!=0 ) Color1.blue  = V+0x7FFF ; else Color1.blue   = 0 ;
      if( (i&0x02)!=0 ) Color1.green = V+0x7FFF ; else Color1.green = 0 ;
      if( (i&0x04)!=0 ) Color1.red   = V+0x7FFF ; else Color1.red  = 0 ;
      if( i==8 ) Color1.red=Color1.green=Color1.blue=0xBFFF ;
      Color1.flags = DoRed|DoGreen|DoBlue ;
      XAllocColor( Dis,Colormap1,&Color1 );
      Color[i] =Color1 ;
   }
   // ------------      --------------

   Pixmap Pix1 = XCreatePixmapFromBitmapData( Dis,RootWindow( Dis,i_Scr),
		 lingvo_bits,lingvo_width,lingvo_height,1,0,1 );

   char *sSlowo="Slowo" ;
   if( !XStringListToTextProperty( &sSlowo,1,&WinName ) ) exit(1);

   // --------------    -----------------------

   SizeHints.flags      = 0 ;

   WMHints.flags         = StateHint | IconPixmapHint | InputHint ;
   WMHints.initial_state = NormalState ;
   WMHints.input         = True ;
   WMHints.icon_pixmap   = Pix1 ;

   ClassHint.res_name    = argv[0] ;
   ClassHint.res_class   = "Slowo" ;

   XSetWMProperties ( Dis,Win, &WinName,&WinName, argv,argc,
		      &SizeHints, &WMHints, &ClassHint );

   XSelectInput( Dis,Win,ExposureMask | KeyPressMask );
   XMapWindow( Dis,Win );
}
/***************************************************************************
void s_goto_xy( short _y, short _x )
{
   x=_x ; y=_y ;
}
/* ----------------------------------------------------------------------- */
int s_shiftstatus( void )
{  return Shiftstatus ;  }
/***************************************************************************/
void ss_get_size( short *X , short *Y )
{
    Window        Win1 ;
    int           x, y;
    unsigned int  width, height;
    unsigned int  border_width;
    unsigned int  depth;

    XGetGeometry( Dis, Win, &Win1, &x, &y, &width, &height, &border_width, &depth);

   *X=Size_X=width ; *Y=Size_Y=height ;
}
/***************************************************************************/
/*                   Ĩ                  */
/***************************************************************************/
void s_getch( short *taste1, short *taste2 )
{
   int     Symbol,Symbol1 ;
   char    Symb[2] ;
   KeySym  RetSym ;
   static  int sp=0 ;
   XEvent  Event1 ;


   XNextEvent( Dis, &Event1 );

   Symbol=0 ; Symbol1=0 ;

   /* ------------------------------------ */
   if( Event1.type == KeyPress )
   {
      XLookupString(&(Event1.xkey), Symb, 1, &RetSym, NULL);

      switch( RetSym )
      {
	 case  XK_Caps_Lock : Shiftstatus=Shiftstatus ; break ;
	 case  XK_Shift_L   : Shiftstatus |= (S_Shift_L); break ;
	 case  XK_Control_L : Shiftstatus |= (S_Ctrl_L); break ;
	 case  XK_Alt_L     : Shiftstatus |= (S_Alt_L); break ;
	 case  XK_Alt_R     : Shiftstatus |= (S_Alt_R); break ;
	 case  XK_Control_R : Shiftstatus |= (S_Ctrl_R); break ;
	 case  XK_Shift_R   : Shiftstatus |= (S_Shift_R); break ;
	 default : goto M1 ;
      }
      goto Ende ;

      M1:
	   switch( RetSym )
	   {
		case  XK_F1:            Symbol1 = S_key_F1;break;
		case  XK_F2:            Symbol1 = S_key_F2;break;
		case  XK_F3:            Symbol1 = S_key_F3;break;
		case  XK_F4:            Symbol1 = S_key_F4;break;
		case  XK_F5:            Symbol1 = S_key_F5;break;
		case  XK_F6:            Symbol1 = S_key_F6;break;
		case  XK_F7:            Symbol1 = S_key_F7;break;
		case  XK_F8:            Symbol1 = S_key_F8;break;
		case  XK_F9:            Symbol1 = S_key_F9;break;
		case  XK_F10:           Symbol1 = S_key_F10;break;

		case  XK_Return:        Symbol  = '\r';  break;
		case  XK_Tab:           Symbol1 = S_key_TabL; break;
		case  XK_Escape:        Symbol  = S_key_Esc;  break;
		case  XK_BackSpace:     Symbol  = S_key_Back; break;
		case  XK_Left:          Symbol1 = S_key_Left; break;
		case  XK_Right:         Symbol1 = S_key_Right;break;
		case  XK_Down:          Symbol1 = S_key_Down; break;
		case  XK_Up:            Symbol1 = S_key_Up;   break;
		case  XK_Insert:        Symbol1 = S_key_Ins;  break;
		case  XK_Delete:        Symbol1 = S_key_Del;  break;
		case  XK_Home:          Symbol1 = S_key_Home; break;
		case  XK_End:           Symbol1 = S_key_End;  break;
		case  XK_Prior:         Symbol1 = S_key_PgUp; break;
		case  XK_Next:          Symbol1 = S_key_PgDn; break;
		case  XK_KP_Add:        Symbol1 = S_key_plus; break;
		case  XK_KP_Subtract:   Symbol1 = S_key_minus;break;
		default:                Symbol  = (int)Symb[0];

	    }
   }
   /* -------------------------------------- */
   if( Event1.type == KeyRelease )
   {
      XLookupString(&(Event1.xkey), Symb, 1, &RetSym, NULL);

      switch( RetSym )
      {
	 case  XK_Caps_Lock : Shiftstatus=Shiftstatus ; break ;
	 case  XK_Shift_L   : Shiftstatus &= (~S_Shift_L); break ;
	 case  XK_Control_L : Shiftstatus &= (~S_Ctrl_L); break ;
	 case  XK_Alt_L     : Shiftstatus &= (~S_Alt_L); break ;
	 case  XK_Alt_R     : Shiftstatus &= (~S_Alt_R); break ;
	 case  XK_Control_R : Shiftstatus &= (~S_Ctrl_R); break ;
	 case  XK_Shift_R   : Shiftstatus &= (~S_Shift_R); break ;

      }
   }
Ende:
   *taste1 = Symbol  ;
   *taste2 = Symbol1 ;
   sp-- ;
   return;
}
/**************************************************************************
extern "C"
{  // -------   glibc   ,   ,  -----
   char *_Xsetlocale( int a, _Xconst char *str )
   {    return str ;  }
};
/***************************************************************************/
//                -
/***************************************************************************/
t_GC :: t_GC( Window _Win, ulong i1, ulong i2 )
{
   if( 16<=i1 ) i1=7 ;
   if( 16<=i2 ) i2=7 ;
   GC1=XCreateGC( Dis,Win,0,NULL );
   XSetFunction(  Dis, GC1, GXcopy );
   XSetForeground( Dis,GC1, Color[i1].pixel );
   XSetBackground( Dis,GC1, Color[i2].pixel );
}
/* ----------------------------------------------------------------------- */
t_GC :: ~t_GC( void )
{  XFreeGC( Dis,GC1 );
}
/* ----------------------------------------------------------------------- */
void t_GC :: SetForeground( ulong i )
{  XSetForeground( Dis,GC1, Color[i].pixel );  }
/* ----------------------------------------------------------------------- */
void t_GC :: SetBackground( ulong i )
{  XSetBackground( Dis,GC1, Color[i].pixel );  }
/* ----------------------------------------------------------------------- */
void t_GC :: DrawImageString( short x, short y, char *Text )
{  XDrawImageString( Dis,Win,GC1,x,y,Text,strlen(Text) );  }
/* ----------------------------------------------------------------------- */
void t_GC :: DrawLine( int x1, int y1, int x2, int y2 )
{  XDrawLine( Dis, Win, GC1, x1, y1, x2, y2 );  }
/* ----------------------------------------------------------------------- */
void t_GC :: FillRectangle( int x1, int y1, int x2, int y2 )
{  XFillRectangle( Dis, Win, GC1, x1, y1, x2, y2);  }
/* ----------------------------------------------------------------------- */
void t_GC :: DrawRectangle( int x1, int y1, int x2, int y2 )
{  XDrawRectangle( Dis, Win, GC1, x1, y1, x2, y2);  }


